Attribute VB_Name = "modConfig"
Option Explicit

Private Declare Function GetTempPath Lib "Kernel32.dll" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Const m_IniName As String = "vbUnit3ST.ini"
Private m_MessageDataFileName As String

Public Function GetTempFile() As String
    GetTempFile = GetTempFolder() & "\vbUnit3ST.tmp"
End Function
Private Function GetTempFolder() As String
    Dim lpBuffer As String * 255
    Dim Path As String

    Call GetTempPath(Len(lpBuffer), lpBuffer)
    Path = Left(lpBuffer, InStr(lpBuffer, vbNullChar) - 1)

    GetTempFolder = Path
End Function

Private Sub GetMessageDataFileName()
    Dim buf As String
    buf = Space(1024)
    Call GetPrivateProfileString("SYSTEM", "MessageFileName", "", buf, Len(buf) - 1, App.Path & "\" & m_IniName)
    buf = Left$(Trim(buf), InStr(Trim(buf), vbNullChar) - 1)
    m_MessageDataFileName = buf
End Sub

Public Function GetInit(ByVal Section As String, ByVal Key As String, Optional ByVal Default As Variant) As String
    If m_MessageDataFileName = "" Then
        Call GetMessageDataFileName
    End If
    Dim buf As String
    buf = Space(1024)
    Call GetPrivateProfileString(Section, Key, Default, buf, Len(buf) - 1, App.Path & "\" & m_MessageDataFileName)
    buf = Left$(Trim(buf), InStr(Trim(buf), vbNullChar) - 1)
    
    GetInit = buf
End Function

Public Function GetMessage(ByVal Section As String, ByVal Key As String, ParamArray options() As Variant) As String
    If m_MessageDataFileName = "" Then
        Call GetMessageDataFileName
    End If
    Dim buf As String
    buf = Space(1024)
    Call GetPrivateProfileString(Section, Key, "", buf, Len(buf) - 1, App.Path & "\" & m_MessageDataFileName)
    buf = Left$(Trim(buf), InStr(Trim(buf), vbNullChar) - 1)
    
    GetMessage = CreateString(buf, options)
End Function

Private Function CreateString(ByVal str As String, ByVal options As Variant)
    Const ModeNormal As Integer = 0
    Const ModeMeta As Integer = 1
    Const ModeIndex As Integer = 2
    
    Dim BufLen As Integer
    Dim i As Long
    Dim IndexString As String
    Dim Index As Integer
    Dim Mode As Integer
    Dim ch As String
    Mode = ModeNormal
    BufLen = Len(str)
    For i = 1 To BufLen
        ch = Mid$(str, i, 1)
        If Mode = ModeMeta Then
            CreateString = CreateString & ch
            Mode = ModeNormal
        ElseIf Mode = ModeIndex Then
            If ch = "}" Then
                Index = CInt(IndexString) - 1
                If LBound(options) <= Index And Index <= UBound(options) Then
                    CreateString = CreateString & options(Index)
                Else
                    CreateString = CreateString & "#missing parameter#"
                End If
                Mode = ModeNormal
            Else
                IndexString = IndexString & ch
            End If
        Else
            Select Case ch
                Case "{"
                    Mode = ModeIndex
                Case "\"
                    Mode = ModeMeta
                Case Else
                    CreateString = CreateString & ch
            End Select
        End If
    Next i
End Function


