VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Connect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "vbUnit3 Basic Support Tools"
'----------------------------------------------
' The Connect Class
'----------------------------------------------

Option Explicit

Implements IDTExtensibility

Private Const ImplementsString As String = "Implements ISuite"

' this addin in the Addins Collection
Private AddinInstance As VBIDE.Addin

' names of related forms

' names of menuitem variables
Private mniRun As Office.CommandBarControl
Private mniSwitchMode As Office.CommandBarControl
Private mniSuiteList As Office.CommandBarControl
Private mniRefresh As Office.CommandBarControl
Private cbVBUnit As CommandBar
Private m_RunInDebugger As Boolean
' names of menuhandler variables
Private WithEvents mnhRun As VBIDE.CommandBarEvents
Attribute mnhRun.VB_VarHelpID = -1
Private WithEvents mnhSwitchMode As VBIDE.CommandBarEvents
Attribute mnhSwitchMode.VB_VarHelpID = -1
Private WithEvents mnhSuiteList As VBIDE.CommandBarEvents
Attribute mnhSuiteList.VB_VarHelpID = -1
Private WithEvents mnhRefresh As VBIDE.CommandBarEvents
Attribute mnhRefresh.VB_VarHelpID = -1


Private Sub IDTExtensibility_OnConnection(ByVal VBInst As Object, ByVal ConnectMode As vbext_ConnectMode, ByVal AddInInst As VBIDE.Addin, Custom() As Variant)
    ' the add-in has been connected to the VB IDE
    On Error GoTo OnConnection_Error
    
    If Not (AddinInstance Is Nothing) Then Exit Sub

    'save the VB instance and the addin instance
    Set g_VBInstance = VBInst
    Set AddinInstance = AddInInst

    If ConnectMode <> vbext_cm_Startup Then
        ' if no AfterStartup method will be called, call it manually
        IDTExtensibility_OnStartupComplete Custom()
    End If
    
    If ConnectMode = vbext_cm_External Then
        ' the add-in has been activated from an external program
        ' (e.g. the Addin Toolbar or after a click on a VBZ file)
        ' init code for external activation
    End If
    
    'StartVBUnit烁bZ[W擾邽߂ɃTuNX
    g_OriginalhWnd = frmStartVBUnitMessageHandler.hwnd
    g_OriginalWndProc = SetWindowLong(g_OriginalhWnd, GWL_WNDPROC, AddressOf WndProc)

    Exit Sub
OnConnection_Error:
    MsgBox "Unable to correctly connect the add-in", vbCritical
    
End Sub

Private Sub IDTExtensibility_OnStartupComplete(Custom() As Variant)
    ' if the add-in is being loaded at VB startup, this is
    ' the right place to add a menu item to the Add-Ins menu
    CreateMenuItems
    
    ' form loading
End Sub

Private Sub IDTExtensibility_OnDisconnection(ByVal RemoveMode As vbext_DisconnectMode, Custom() As Variant)
    On Error Resume Next
   
    'TuNX
    Call SetWindowLong(g_OriginalhWnd, GWL_WNDPROC, g_OriginalWndProc)
    
    DestroyMenuItems
    
    ' form unloading
    
    Set AddinInstance = Nothing
End Sub

Private Sub IDTExtensibility_OnAddInsUpdate(Custom() As Variant)
     ' a new addin has been added or removed to the VB IDE
     ' (unused)
End Sub

Sub Show(frm As Object, Optional modal As Integer)
    ' show the associated form or UserDoc
    Set frm.g_VBInstance = g_VBInstance
    Set frm.Connect = Me
    
    If TypeOf frm Is VB.Form Then
        frm.Show modal
    Else
        frm.Window.Visible = True
    End If
End Sub

Sub Hide(frm As Object)
    ' hide the associated form or UserDoc
    If TypeOf frm Is VB.Form Then
        Unload frm
    Else
        frm.Window.Visible = False
    End If
End Sub

Sub CreateMenuItems()
    ' create all the user interface items
    On Error GoTo CreateMenuItems_Error
    
    Set cbVBUnit = g_VBInstance.CommandBars.Add
    cbVBUnit.Position = msoBarTop
    cbVBUnit.Visible = True
    cbVBUnit.Name = App.ProductName & " " & App.Major & "." & App.Minor & App.Revision
    With cbVBUnit.Controls
        Set mniRun = .Add(msoControlButton)
        mniRun.BeginGroup = True
        mniRun.Caption = GetMessage("AddIn", "RunCaption")
        mniRun.Style = msoButtonCaption
        mniRun.ToolTipText = GetMessage("AddIn", "RunToolTipText")
        Set mnhRun = g_VBInstance.Events.CommandBarEvents(mniRun)
    
        Set mniRefresh = .Add(msoControlButton)
        mniRefresh.BeginGroup = True
        mniRefresh.Caption = GetMessage("AddIn", "RefreshCaption")
        mniRefresh.Style = msoButtonCaption
        mniRefresh.ToolTipText = GetMessage("AddIn", "RefreshToolTipText")
        Set mnhRefresh = g_VBInstance.Events.CommandBarEvents(mniRefresh)
        
        Dim cbcb As CommandBarComboBox
        Set cbcb = .Add(msoControlComboBox)
        cbcb.Width = 300
        Set mniSuiteList = cbcb
        Set mnhSuiteList = g_VBInstance.Events.CommandBarEvents(mniSuiteList)
        
        
        Dim cbb As CommandBarButton
        Set mniSwitchMode = .Add(msoControlButton)
        mniSwitchMode.BeginGroup = True
        mniSwitchMode.Caption = GetMessage("AddIn", "SwitchModeCaption")
        mniSwitchMode.Style = msoButtonCaption
        mniSwitchMode.ToolTipText = GetMessage("AddIn", "SwitchModeToolTipText")
        Set cbb = mniSwitchMode
        cbb.State = msoButtonDown
        m_RunInDebugger = True
        Set mnhSwitchMode = g_VBInstance.Events.CommandBarEvents(mniSwitchMode)
        
    End With
    
    Exit Sub
CreateMenuItems_Error:
    MsgBox "Unable to create necessary menu items", vbCritical
End Sub

Sub DestroyMenuItems()
    'delete the menu items and clear the menu handler objects
    
    ' menuitem deletion
    mniRun.Delete
    mniSwitchMode.Delete
    mniSuiteList.Delete
    mniRefresh.Delete
    cbVBUnit.Delete

    Set mnhRun = Nothing
    Set mnhSwitchMode = Nothing
    Set mnhSuiteList = Nothing
    Set mnhRefresh = Nothing
    Set cbVBUnit = Nothing
End Sub

' menuhandler event routines
Private Sub mnhRun_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    ' add here the code for the "Run vbUnit" menu item
    On Error GoTo ErrHandler
    
    Dim FileNumber As Long
    
    'Suite̒o
    Dim SuiteNames As String
    SuiteNames = Join(GetSuiteNames(), " ")
    If SuiteNames = "" Then
        MsgBox GetMessage("AddIn", "NoTestSuite"), vbCritical, App.ProductName
        Exit Sub
    End If

    'StartVBUnitɑp[^̍쐬
    If Dir$(GetTempFile) <> "" Then
        Kill GetTempFile
    End If
    FileNumber = FreeFile()
    Open GetTempFile For Output As #FileNumber
    Print #FileNumber, SuiteNames
    If m_RunInDebugger = True Then
        Print #FileNumber, frmStartVBUnitMessageHandler.hwnd
    Else
        Print #FileNumber, 0
    End If
    Dim cbcb As CommandBarComboBox
    Set cbcb = mniSuiteList
    Print #FileNumber, cbcb.Text
    Close #FileNumber
    
    'pXύXStartVBUnitN
    g_PathBackup = Environ$("PATH")
    Call SetEnvironmentVariable("PATH", App.Path & ";" & g_PathBackup)
    
    'IDEsԂɂ
    If m_RunInDebugger = True Then
        
        g_VBInstance.CommandBars.FindControl(, 746).Execute
    Else
        Call Shell("StartVBUnit.exe")
    End If
    
    Exit Sub
ErrHandler:
    If FileNumber <> 0 Then
        Close #FileNumber
    End If
    MsgBox Err.Description
End Sub

Private Sub mnhSwitchMode_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Dim cbb As CommandBarButton
    m_RunInDebugger = Not m_RunInDebugger
    Set cbb = CommandBarControl
    If m_RunInDebugger = True Then
        cbb.State = msoButtonDown
    Else
        cbb.State = msoButtonUp
    End If
End Sub

Private Sub mnhRefresh_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Call RefreshItems
End Sub

Private Sub RefreshItems()
    Dim cbcb As CommandBarComboBox
    Dim SuiteNames() As String
    Dim i As Long
    
    Set cbcb = mniSuiteList
    cbcb.Clear
    cbcb.AddItem ""
    SuiteNames = GetSuiteNames
    For i = LBound(SuiteNames) To UBound(SuiteNames)
        cbcb.AddItem SuiteNames(i)
    Next i
    If cbcb.ListCount > 1 Then
        cbcb.ListIndex = 2
    End If
End Sub

Private Function GetSuiteNames() As String()
    Dim ListNames() As String
    Dim vbp As VBProject
    Dim vbc As VBComponent
    Dim Count As Long
    ListNames = Split("")
    Count = 0
    If g_VBInstance.VBProjects.Count <= 0 Then
        GetSuiteNames = ListNames
        Exit Function
    End If
    
    For Each vbp In g_VBInstance.VBProjects
        For Each vbc In vbp.VBComponents
            If vbc.Type <> vbext_ct_RelatedDocument Then
                Dim i As Long
                For i = 1 To vbc.CodeModule.CountOfDeclarationLines
                    If vbc.CodeModule.Find(ImplementsString, i, 1, i, 2, True) = True Then
                        ReDim Preserve ListNames(0 To Count)
                        ListNames(Count) = vbp.Name & "." & vbc.Name
                        Count = Count + 1
                        Exit For
                    End If
                Next i
            End If
        Next vbc
    Next vbp
    GetSuiteNames = ListNames
End Function
